#include "smtp.h"

extern smtpi jtin;

void smtpstats_init()
   {
   pth_mutex_t mutex = PTH_MUTEX_INIT;
   pth_mutex_acquire(&mutex, TRUE, NULL);
   time_t now_unixtime;
   struct tm now;
   pool p;
   char *lcFile;
   int liYear;

__HHUNG   smtp_PoolsReg(7601, (p=pool_new()));

__HHUNG   now_unixtime = time(NULL);
__HHUNG   gmtime_r(&now_unixtime, &now);
__HHUNG   liYear =now.tm_year+1900;

   // pokud je soubor nahranej, testuj rok
__HHUNG   if (jtin->smtpstats!=NULL)
      {
__HHUNG      if (j_atoi(xmlnode_get_attrib(jtin->smtpstats,"id"),0)!=liYear)
         {
__HHUNG         xmlnode_free(jtin->smtpstats);
__HHUNG         jtin->smtpstats=NULL;
         }
      }

__HHUNG   if (jtin->smtpstats==NULL)
      {
__HHUNG      lcFile=spools(p,jtin->smtpstats_folder,"/",smtp_itoa( p,liYear),".xml",p);
__HHUNG      if ((jtin->smtpstats=xmlnode_file(lcFile))==NULL)
         { // file not exist or any other bug

__HHUNG         if (access(lcFile,F_OK)!=0)
__HHUNG            log_error("smtp","Transport cannot load smtpstats file (%s).",lcFile);

         // create new file
__HHUNG         jtin->smtpstats=xmlnode_new_tag("year");
__HHUNG         smtp_PoolsReg(7600, xmlnode_pool(jtin->smtpstats));
__HHUNG         smtp_PoolsSettmp(xmlnode_pool(jtin->smtpstats), 0);
__HHUNG         smtp_PoolsSetData(xmlnode_pool(jtin->smtpstats), (void*) jtin->smtpstats);
__HHUNG         xmlnode_put_attrib(jtin->smtpstats,"id",smtp_itoa( p,liYear));
         }
      }   

__HHUNG   pool_free(p);
__HHUNG   pth_mutex_release(&mutex);
   }

void smtpstats_add(char *lcFrom, char *lcTo)
   {
   time_t now_unixtime;
   struct tm now;
   xmlnode loDay,loJID,loCopy,loRcpt,loSMTPstats;
   pool p;
   char *lcDate,*lcJID,*lcFile;
   int lii,liLimit;
   #ifdef SMTP_DB
    SMTP_DEBUG(SMTP_ZONE,"SMPT: Registration SMTPSTATS pool");
   #endif

   return; // return for Pinky, please comment this line for testing where transport will be hung 

__HHUNG   smtpstats_init(); // inicializace
   
__HHUNG   if (jtin->smtpstats==NULL)
      return;


__HHUNG   smtp_PoolsReg(7610, (p=pool_new()));


__HHUNG   pth_mutex_t mutex = PTH_MUTEX_INIT;
__HHUNG   pth_mutex_acquire(&mutex, TRUE, NULL);

__HHUNG   now_unixtime = time(NULL);
__HHUNG   gmtime_r(&now_unixtime, &now);

__HHUNG   lcJID=lcFrom;
   
   // najdi dle datumu zda ma JID, pokudne zaloit, pokud ano, inkrementuj
__HHUNG   lcDate = (char*)pmalloc_x(p, 11,' ');
__HHUNG   snprintf(lcDate, j_strlen(lcDate), "%04i-%02i-%02i\0", now.tm_year+1900, now.tm_mon+1, now.tm_mday);
__HHUNG   loDay=xmlnode_get_tag(jtin->smtpstats,spools(p,"day?id=",lcDate,p));
__HHUNG   if (loDay==NULL)
      {
//      SMTP_DEBUG(SMTP_ZONE,"JABSTATS - add day %s",lcDate);
__HHUNG      loDay=xmlnode_insert_tag(jtin->smtpstats,"day");
__HHUNG      xmlnode_put_attrib(loDay,"id",lcDate);
__HHUNG      loJID=NULL;
      } 
   else
      {
//      SMTP_DEBUG(SMTP_ZONE,"JABSTATS - test jid %s of date %s",lcJID,lcDate);
__HHUNG      loJID=xmlnode_get_tag(loDay,spools(p,"jid?from=",lcJID,p));
      } 

__HHUNG   if (loJID==NULL)
      {
//      SMTP_DEBUG(SMTP_ZONE,"JABSTATS - add jid %s",lcJID);
__HHUNG      loJID=xmlnode_insert_tag(loDay,"jid");
__HHUNG      xmlnode_put_attrib(loJID,"from",lcJID);
__HHUNG      xmlnode_put_attrib(loJID,"count","1");
__HHUNG      xmlnode_put_attrib(loJID,"stepover","0");
__HHUNG      lii=1;
      }
   else
      {
//      SMTP_DEBUG(SMTP_ZONE,"JABSTATS - update jid %s",lcJID);
__HHUNG      lii=j_atoi(xmlnode_get_attrib(loJID,"count"),0)+1;
__HHUNG      xmlnode_put_attrib(loJID,"count",smtp_itoa( p,lii));
      }

   // ulo do loJID adresu pjemce
__HHUNG   loRcpt=xmlnode_get_tag(loJID,spools(p,"recipient?to=",lcTo,p));
__HHUNG   if (loRcpt==NULL)
      {
__HHUNG      loRcpt=xmlnode_insert_tag(loJID,"recipient");
__HHUNG      xmlnode_put_attrib(loRcpt,"to",lcTo);
__HHUNG      xmlnode_put_attrib(loRcpt,"count","1");
      }
   else
      {
__HHUNG      lii=j_atoi(xmlnode_get_attrib(loRcpt,"count"),0)+1;
__HHUNG      xmlnode_put_attrib(loRcpt,"count",smtp_itoa( p,lii));
      }

   // vytvo statistiku - kdo a kdy poslal message z smtp
   // <year id="2008">
   //  <day id="yyyymmdd">
   //   <jid from="bla@xx.cz" count="1" >
   //    <recipient to="blah@xx.cz count="1" />
   //   </jid>
   //  </day>
   // </year>

   // nyn otestuj zda nepekroil limit za den
   // limit me bt nastaven individuln pro JID
__HHUNG   liLimit=0;
__HHUNG   if ((loSMTPstats=xmlnode_get_tag(jtin->config,spools(p,"smtp/stats/item?email=",lcJID,p))))
             {
__HHUNG      liLimit=j_atoi(xmlnode_get_attrib(loSMTPstats,"daymaxlimit"),SMTP_SMTPSTATS_DAYMAXLIMIT);
             }
          else
             { 
__HHUNG      if ((loSMTPstats=xmlnode_get_tag(jtin->config,"smtp/stats")))
                {
__HHUNG         liLimit=j_atoi(xmlnode_get_attrib(loSMTPstats,"daymaxlimit"),SMTP_SMTPSTATS_DAYMAXLIMIT);
                }
             }

__HHUNG   if (liLimit>0 && lii>=liLimit &&
       j_atoi(xmlnode_get_attrib(loJID,"stepover"),0)==0
      )
      {
__HHUNG      smtp_SendInfoToAdmin(spools(p,"The sender ",lcJID," step over day limit: ",smtp_itoa( p,liLimit),".",p),SMTP_SITA_M );
__HHUNG      xmlnode_put_attrib(loJID,"stepover","1");
      }


   // ulo XML, pes kopii
__HHUNG   loCopy=xmlnode_dup_pool(p,jtin->smtpstats);
__HHUNG   lcFile=spools(p,jtin->smtpstats_folder,"/",xmlnode_get_attrib(jtin->smtpstats,"id"),".xml",p);
__HHUNG   if (xmlnode2file(lcFile,loCopy)!=1)
      {
__HHUNG      log_alert("smtp","SMTPSTATS - Cannot save file %s.",lcFile);
__HHUNG      smtp_SendInfoToAdmin(spools(p,"SMTPSTATS - Cannot save file ",lcFile,".",p ),SMTP_SITA_P);
      }


__HHUNG   pool_free(p);
__HHUNG   pth_mutex_release(&mutex);
   }
